//+------------------------------------------------------------------+
//|                                          TrailingStop Expert.mq4 |
//|                                                          Alex-W- |
//|                                              mail: alex-w-@bk.ru |
//+------------------------------------------------------------------+
#property copyright "Alex-W-"
#property link      "mail: alex-w-@bk.ru"
#property version   "1.00"
#property strict

//         1 
//      ,     
//         
//         
//     
//       .

//-------------------    -------------------+
extern int  Distance    = 90;                                              //     .
extern bool TrallProfit = true;                                            //              Distance.
extern int  MagicNum    = 0;
extern bool UseSound    = true;                                            //    .

//------------------    ----------------+
string  NameFileSound      = "news.wav";                                //   
int     NumberOfTry        = 3;                                         //    .
int     TSIdObjets[];                                                   //      .

//---------------------   ---------------------+
#include      <stdlib.mqh>                                              //   4


//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
//---
   
//---
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
//---
   for(int i=0; i<ArraySize(TSIdObjets); i++)
      ObjectDelete(IntegerToString(TSIdObjets[i]));
   
}

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
//---
   TrailingStopOrders("", Distance, MagicNum,TrallProfit);
}

//+------------------------------------------------------------------+
//|  : Pozitif        mail: alex-w-@bk.ru                       |
//+------------------------------------------------------------------+
//| TrailingStop   .                                   |
//|                  |
//|                     |
//|      .            |
//+------------------------------------------------------------------+
//|   .                                    |
//| TSIdObjets[]  -  ,    . |
//+------------------------------------------------------------------+
//| :                                                       |
//|   sy - Symbol ("" -  , "all"-  )      |
//|   ts -                                       |
//|   mn - Magic  (0)                                   |
//|   tp -        .          |
//|   st -     .                      |
//+------------------------------------------------------------------+
void TrailingStopOrders(string sy="", int ts=0, int mn=0, bool tp = false, int st=2){
//---
   int dg, orType, minLevel, tsPt, err, orCx, orTk, arrSz=0, arrCx=0, arrTemp[];
   double prBid, prAsk, pt, orOpPr, orSl, orTp, prSl=0, objPr, linePrSt;
   string orSy, sOrTk;
//---
   if(sy=="")sy=Symbol();
   orCx=OrdersTotal();

   for(int i=orCx; i>0; i--){
      
      if(!OrderSelect(i-1, SELECT_BY_POS, MODE_TRADES)){
         err = GetLastError();
         Print("Error(",err,"), CloseOrders() -> OrderSelect() ",ErrorDescription(err));
         continue;
      }

      orSy = OrderSymbol();
      prBid = MarketInfo(orSy, MODE_BID);
      prAsk = MarketInfo(orSy, MODE_ASK);
      minLevel = MarketInfo(orSy, MODE_STOPLEVEL);
      pt = MarketInfo(orSy, MODE_POINT);
      dg = MarketInfo(orSy, MODE_DIGITS);
      orOpPr = OrderOpenPrice();
      orType = OrderType();
      orSl = OrderStopLoss();
      orTp = OrderTakeProfit();
      orTk = OrderTicket();
      sOrTk=IntegerToString(orTk);
      
      if((orType==OP_BUY)||(orType==OP_SELL)){
         
         if((sy==OrderSymbol() || sy=="all")&&(mn==OrderMagicNumber() || mn==0)){
            
            //---   ,     ---//
            if(ObjectFind(sOrTk)>=0){
               objPr=ObjectGet(sOrTk,OBJPROP_PRICE1);
               if((objPr >= prBid && orType == OP_BUY) || (objPr <= prAsk && orType==OP_SELL)){
                  CloseOrders(orSy, orType, -1, orTk, mn);
                  SetLineX(sOrTk);
                  continue;
               }
            }
         
            //---          ---//
            if(ts < minLevel){
               
               tsPt=minLevel+5;
               
               //---        ---//
               if(orType==OP_BUY){
                  linePrSt=NormalizeDouble(prBid-((ts)*pt), dg);
                  
                  if(!tp || ((prBid-orOpPr) > ts*pt)){
                  
                     //---  Id    ---//
                     if(ObjectFind(sOrTk)<0){
                        arrSz=ArraySize(TSIdObjets);
                        ArrayResize(TSIdObjets, arrSz+1, 200);
                        TSIdObjets[arrSz]=orTk;
                        SetLineX(sOrTk, linePrSt, " #virt sl: "+sOrTk);
                     }
                     
                     if(ObjectGet(sOrTk,OBJPROP_PRICE1)<linePrSt)
                        SetLineX(sOrTk, linePrSt, "#virt sl: "+sOrTk);
                  }
               }
               else{
                  linePrSt=NormalizeDouble(prAsk+(ts*pt), dg);
                  
                  if(!tp || ((orOpPr-prAsk) > ts*pt)){
                  
                     //---  Id    ---//
                     if(ObjectFind(sOrTk)<0){
                        arrSz=ArraySize(TSIdObjets);
                        ArrayResize(TSIdObjets, arrSz+1, 200);
                        TSIdObjets[arrSz]=orTk;
                        SetLineX(sOrTk, linePrSt, "#virt sl: "+sOrTk);
                     }
                     
                     if(ObjectGet(sOrTk,OBJPROP_PRICE1)>linePrSt)
                        SetLineX(sOrTk, linePrSt, " #virt sl: "+sOrTk);
                  }
               }
            }
            else tsPt = ts;
            
            if(orType==OP_BUY){
               prSl = NormalizeDouble(prBid-((tsPt+st)*pt), dg);
               if(!tp || ((prBid-orOpPr) > (tsPt+st)*pt)){
                  if(orSl<prSl){
                     prSl=NormalizeDouble(prBid-tsPt*pt, dg);
                     ModifyOrder(orOpPr, prSl, orTp);
                  }
               }
            }
            if(orType==OP_SELL){
               prSl = NormalizeDouble(prAsk+((tsPt+st)*pt), dg);
               if(!tp || ((orOpPr-prAsk)>(tsPt+st)*pt)){
                  if(orSl>prSl || orSl==0){
                     prSl=NormalizeDouble(prAsk+tsPt*pt, dg);
                     ModifyOrder(orOpPr, prSl, orTp);
                  }
               }
            }
         }
      }
   }
   //---        ,   ---//
   arrSz=ArraySize(TSIdObjets);
   if(arrSz>0){
      arrCx=0;
      for(int j=0; j<arrSz; j++){
         if(OrderSelect(TSIdObjets[j], SELECT_BY_TICKET, MODE_TRADES)){
            if(OrderCloseTime()!=0){
               if(ObjectFind(IntegerToString(TSIdObjets[j]))>=0)ObjectDelete(IntegerToString(TSIdObjets[j]));
               TSIdObjets[j]=0;
               continue;
            }
            ArrayResize(arrTemp, arrCx+1);
            arrTemp[arrCx]=TSIdObjets[j];
            arrCx++;
         }
      }
      if(arrSz>0){
         ArrayResize(TSIdObjets, arrCx);
         ArrayCopy(TSIdObjets, arrTemp);
      }
   }
}
//+------------------------------------------------------------------+
//|  : Pozitif        mail: alex-w-@bk.ru                       |
//+------------------------------------------------------------------+
//|     ,         | 
//|    .                                       |
//+------------------------------------------------------------------+
//| :                                                       |
//|   id -   .                                   |
//|   pr -  (),   .        |
//|            .                          |
//|   ds -                                            |
//|   wt -                                                |
//|   ls -                                                 |
//|   cl -                                                  |
//+------------------------------------------------------------------+
void SetLineX(string id, double pr=0, string ds="", int wt=1, int ls= STYLE_DASHDOT, color cl=clrRed){
   
   if(pr!=0){
      if(ObjectFind(id)>=0) ObjectSet(id, OBJPROP_PRICE1, pr);
      ObjectCreate(id, OBJ_HLINE, 0, 0, pr);
      ObjectSet(id, OBJPROP_WIDTH, wt);
      ObjectSet(id, OBJPROP_STYLE, ls);
      ObjectSet(id, OBJPROP_COLOR, cl);
      ObjectSet(id, OBJPROP_TIMEFRAMES, NULL);
      ObjectSetText(id, ds, 12, "Times New Roman", CLR_NONE);
   }else{
      if(ObjectFind(id)>=0)ObjectDelete(id);
   }
}
//+------------------------------------------------------------------+
//|  : Pozitif        mail: alex-w-@bk.ru                       |
//+------------------------------------------------------------------+
//| ModifyOrder.     .|
//+------------------------------------------------------------------+
//| :                                                       |
//|   pr  -                                       |
//|   sl  - stoploss ()                                          |
//|   tp  - takeprofit ()                                        |
//|   cl  -                                     |
//+------------------------------------------------------------------+
void ModifyOrder(double pr=-1, double sl=0, double tp=0, color cl=CLR_NONE){
  double op, os, ot;
  int    dg, err, it;
//--- 
  if (pr<=0) pr=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  dg=MarketInfo(OrderSymbol(), MODE_DIGITS);
  pr=NormalizeDouble(pr, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);
 
  if (pr!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      if (OrderModify(OrderTicket(), pr, sl, tp, 0, cl)) {
        if (UseSound) PlaySound(NameFileSound); break;
      }else{
        err=GetLastError();
        Print("#Error(",err,") ModifyOrder(): ",ErrorDescription(err),", try ",it);
        Sleep(1000*10);
      }
    }
  }
}
//+------------------------------------------------------------------+
//|  : Pozitif        mail: alex-w-@bk.ru                       |
//+------------------------------------------------------------------+
//|   ,   .                        |
//+------------------------------------------------------------------+
//| :                                                       |
//|   sy - Symbol ("" -  , "all"-  )      |
//|   op -   OP_BUY, OP_SELL (-1)                   |
//|   pr - (1)- , (0)-, (-1) .            |
//|   tk -   (0    ,(-1)  )    |
//|   mn - Magic  (-1)                                  |
//|   cl -                                |
//+------------------------------------------------------------------+
void CloseOrders(string sy="", int op=-1, int pr=-1, int tk=-1, int mn=-1, color cl=CLR_NONE){
//---
   int orCx, err, orType;
   double clPr, prBid, prAsk;
//---
   if(sy=="")sy=Symbol();
   if(tk>0||tk==0)orCx=1;
   else orCx=OrdersTotal();
   
   for(int i=orCx; i>0; i--){
      //---------------       ----------
      for(int cx=0; cx<NumberOfTry; cx++){
         if(tk>0 && tk!=0){
            //---   
            if(!OrderSelect(tk, SELECT_BY_TICKET, MODE_TRADES)){
               err = GetLastError();
               Print("Error(",err,") CloseOrders() -> OrderSelect(): ",ErrorDescription(err));
               continue;
            }
         }
         //--------------        ---------
         if(tk<0){
            if(!OrderSelect(i-1, SELECT_BY_POS, MODE_TRADES)){
               err = GetLastError();
               Print("Error(",err,"), CloseOrders() -> OrderSelect() ",ErrorDescription(err));
               continue;
            }
         }
         orType=OrderType();
         if((orType==OP_BUY)||(orType==OP_SELL)){
            if((sy==OrderSymbol()||sy=="all")&&(mn==OrderMagicNumber()||mn<0)){
               if((op<0)||(op==orType)){
                  if(((pr>0)&&(OrderProfit()>0))||((pr==0)&&(OrderProfit()<0))||(pr<0)){
            
                     prBid=MarketInfo(OrderSymbol(), MODE_BID);
                     prAsk=MarketInfo(OrderSymbol(), MODE_ASK);
            
                     if(OrderType()==OP_BUY)clPr=prBid;
                     if(OrderType()==OP_SELL)clPr=prAsk;
         
                     if(OrderClose(OrderTicket(), OrderLots(), clPr, 0, cl)){
                        if (UseSound) PlaySound(NameFileSound);
                        break;
                     }
                     else err=GetLastError();
                     Print("Error(",err,") CloseOrders() -> OrderClose(): ",ErrorDescription(err),", try ",cx);
      
                     if(err==1||err==2||err==3||err==5) break;                      // 1- ,   , 2- , 3- , 5-   
                     if(err==64||err==65||err==133||err==139) break;                // 64- , 65-  , 133- , 139-    ,
                     if(err==4||err==131||err==132) Sleep(1000*60);                 // 4-  , 131- , 132- 
                     if(err==141) Sleep(1000*10);                                   // 141-  
                     if(err==146) while (IsTradeContextBusy()) Sleep(1000*10);      // 146-  
                     if(err==135) Sleep(500);                                       // 135- 
                  }
               }
            }
         }
      }
   }
}

//+------------------------------------------------------------------+